Index: /trunk/src/org/expeditee/gui/FrameMouseActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 1102)
@@ -19,20 +19,5 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Image;
-import java.awt.Point;
-import java.awt.Rectangle;
-import java.awt.Toolkit;
-import java.awt.datatransfer.Clipboard;
-import java.awt.datatransfer.DataFlavor;
-import java.awt.datatransfer.Transferable;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.KeyEvent;
 import java.awt.event.MouseEvent;
-import java.awt.event.MouseListener;
-import java.awt.event.MouseMotionListener;
-import java.awt.event.MouseWheelEvent;
-import java.awt.event.MouseWheelListener;
 import java.text.NumberFormat;
 import java.util.ArrayList;
@@ -45,11 +30,15 @@
 import java.util.List;
 import java.util.Set;
-import java.util.TimerTask;
-
-import javax.swing.Timer;
 
 import org.expeditee.actions.Actions;
 import org.expeditee.actions.Misc;
 import org.expeditee.actions.Navigation;
+import org.expeditee.core.AxisAlignedBoxBounds;
+import org.expeditee.core.Colour;
+import org.expeditee.core.OSManager;
+import org.expeditee.core.Point;
+import org.expeditee.core.swing.SwingConversions;
+import org.expeditee.gio.gesture.Gesture;
+import org.expeditee.gio.gesture.GestureListener;
 import org.expeditee.gui.indirect.mouse.IndirectMouseActions;
 import org.expeditee.gui.indirect.mouse.MouseAction;
@@ -71,14 +60,14 @@
 import org.expeditee.items.UserAppliedPermission;
 import org.expeditee.items.XRayable;
-import org.expeditee.items.widgets.ButtonWidget;
+/*import org.expeditee.items.widgets.ButtonWidget; TODO: Reinstate. cts16
 import org.expeditee.items.widgets.InteractiveWidget;
 import org.expeditee.items.widgets.WidgetCorner;
-import org.expeditee.items.widgets.WidgetEdge;
+import org.expeditee.items.widgets.WidgetEdge;*/
 import org.expeditee.settings.UserSettings;
 import org.expeditee.settings.experimental.ExperimentalFeatures;
 import org.expeditee.stats.SessionStats;
 
-public class FrameMouseActions implements MouseListener, MouseMotionListener,
-		MouseWheelListener {
+public class FrameMouseActions
+{
 
 	private static int _lastMouseClickModifiers = 0;
@@ -92,5 +81,5 @@
 			@Override
 			public List<Item> exec(MouseInfo info) {
-				//if user is not pointing at something,this is a back
+				//if user is not pointing at something, this is a back
 				if (info.isControlDown || info.isShiftDown)
 					forward();
@@ -105,6 +94,5 @@
 				// check for TDFC permission
 				if (!info.clicked.hasPermission(UserAppliedPermission.createFrames)) {
-					MessageBay
-							.displayMessage("Insufficient permission to TDFC (Top Down Frame Creation) from that item");
+					MessageBay.displayMessage("Insufficient permission to TDFC (Top Down Frame Creation) from that item");
 					return null;
 				}
@@ -178,12 +166,8 @@
 				copies.add(new Line(d[3], d[0], current.getNextItemID()));
 
-				new Constraint(d[0], d[1], current.getNextItemID(),
-						Constraint.HORIZONTAL);
-				new Constraint(d[2], d[3], current.getNextItemID(),
-						Constraint.HORIZONTAL);
-				new Constraint(d[1], d[2], current.getNextItemID(),
-						Constraint.VERTICAL);
-				new Constraint(d[3], d[0], current.getNextItemID(),
-						Constraint.VERTICAL);
+				new Constraint(d[0], d[1], current.getNextItemID(), Constraint.HORIZONTAL);
+				new Constraint(d[2], d[3], current.getNextItemID(), Constraint.HORIZONTAL);
+				new Constraint(d[1], d[2], current.getNextItemID(), Constraint.VERTICAL);
+				new Constraint(d[3], d[0], current.getNextItemID(), Constraint.VERTICAL);
 
 				anchor(new ArrayList<Item>(copies));
@@ -233,6 +217,5 @@
 				Collection<Item> enclosed = getFullyEnclosedItems(info.clickedIn);
 				if (enclosed.size() == 0) {
-					MessageBay
-							.displayMessage("Insufficient permission to copy items");
+					MessageBay.displayMessage("Insufficient permission to copy items");
 				} else {
 					copies = copy(enclosed);
@@ -308,18 +291,15 @@
 				List<Item> copies = new ArrayList<Item>();
 				if (info.clicked != null) {
-					Collection<Item> leftOver = merge(FreeItems
-							.getInstance(), info.clicked);
+					Collection<Item> leftOver = merge(FreeItems.getInstance(), info.clicked);
 					anchor(leftOver);
 				}
 				// This is executed when the user is putting down a line
 				// endpoint and unreeling. ie. Normal unreeling
-				copies = ItemUtils.UnreelLine(FreeItems.getInstance(),
-						_controlDown);
-
-				if (copies == null)
-					copies = copy(FreeItems.getInstance());
+				copies = ItemUtils.UnreelLine(FreeItems.getInstance(), _controlDown);
+
+				if (copies == null) copies = copy(FreeItems.getInstance());
+				
 				anchor(FreeItems.getInstance());
-				for (Item i : copies)
-					i.setOffset(0, 0);
+				for (Item i : copies) i.setOffset(0, 0);
 				// need to move to prevent cursor dislocation
 				move(copies);
@@ -354,6 +334,5 @@
 							if (next instanceof Line)
 								continue;
-							double distance = Point.distance(currentX,
-									currentY, next.getX(), next.getY());
+							double distance = Point.distance((int) currentX, (int) currentY, next.getX(), next.getY());
 							if (distance < shortestDistance) {
 								shortestDistance = distance;
@@ -469,6 +448,5 @@
 			public List<Item> exec(MouseInfo info) {
 				List<Item> copies = new ArrayList<Item>();
-				Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(), Math
-						.round(MouseX), Math.round(MouseY), true);
+				Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(), Math.round(MouseX), Math.round(MouseY), true);
 				// If we have permission to copy this item then pick it up
 				if (on != null && on.isLineEnd()
@@ -479,5 +457,5 @@
 				}
 
-				if (on instanceof WidgetEdge) {
+/*				if (on instanceof WidgetEdge) { TODO: Reinstate. cts16
 					// Don't allow the user to break widget edges.
 					// Note: had to return here because random dots would
@@ -485,5 +463,5 @@
 					// with create line.
 					return copies;
-				}
+				}*/
 
 				// if its on a line then split the line and put a point on it and
@@ -519,7 +497,7 @@
 				List<Item> copies = new ArrayList<Item>();
 				ArrayList<Item> toPickup = new ArrayList<Item>(info.clickedIn.size());
-				for (Item ip : info.clickedIn)
-					if (ip.hasPermission(UserAppliedPermission.full))
-						toPickup.add(ip);
+				for (Item ip : info.clickedIn) {
+					if (ip.hasPermission(UserAppliedPermission.full)) toPickup.add(ip);
+				}
 				pickup(toPickup);
 				// otherwise the user is creating a line
@@ -532,9 +510,8 @@
 				List<Item> items = new ArrayList<Item>();
 				// BROOK: WIDGET RECTANGLES DONT ALLOW DISCONNECTION
-				if (info.clicked instanceof Line && !(info.clicked instanceof WidgetEdge)) {
+				if (info.clicked instanceof Line/* && !(info.clicked instanceof WidgetEdge) TODO: Reinstate. cts16*/) {
 					// Check if within 20% of the end of the line
 					Line l = (Line) info.clicked;
-					Item toDisconnect = l.getEndPointToDisconnect(_lastMouseClick
-							.getX(), _lastMouseClick.getY());
+					Item toDisconnect = l.getEndPointToDisconnect(_lastMouseClick.getX(), _lastMouseClick.getY());
 
 					if (toDisconnect == null) {
@@ -696,6 +673,6 @@
 
 	public static FrameMouseActions getInstance() {
-		if (_instance == null)
-			_instance = new FrameMouseActions();
+		if (_instance == null) _instance = new FrameMouseActions();
+		
 		return _instance;
 	}
@@ -708,6 +685,4 @@
 	private static final int MINIMUM_RANGE_DEPRESS_TIME = 250;
 
-	private static final int RECTANGLE_TO_POINT_THRESHOLD = 20;
-
 	private static Date _lastMouseClickDate = new Date();
 
@@ -717,14 +692,4 @@
 
 	public static final int BIG_MOUSE_PAUSE = 750;
-
-	public static final int CONTEXT_FREESPACE = 0;
-
-	public static final int CONTEXT_AT_TEXT = 1;
-
-	public static final int CONTEXT_AT_LINE = 2;
-
-	public static final int CONTEXT_AT_DOT = 3;
-
-	public static final int CONTEXT_AT_ENCLOSURE = 4;
 
 	public static int _alpha = -1;
@@ -765,7 +730,4 @@
 	private static boolean _extrude = false;
 
-	// keeps track of the last highlighted Item
-	private static Item _lastHighlightedItem = null;
-
 	// keeps track of the item being 'ranged out' if there is one.
 	private static Text _lastRanged = null;
@@ -773,17 +735,4 @@
 	// keeps track of the picture being cropped if there is one
 	private static Picture _lastCropped = null;
-
-	// true if lastItem only has highlighting removed when a new item is
-	// highlighted
-	private static boolean _lastHoldsHighlight = false;
-
-	private static boolean _forceArrowCursor = true;
-
-	// the current context of the cursor
-	private static int _context = 0;
-
-	public static void setForceArrow(boolean val) {
-		_forceArrowCursor = val;
-	}
 
 	public static int getContext() {
@@ -807,6 +756,5 @@
 				public void actionPerformed(ActionEvent ae) {
 					// check if we are in free space
-					if (_lastClickedOn == null
-							&& FreeItems.getInstance().size() == 0) {
+					if (_lastClickedOn == null && FreeItems.getInstance().size() == 0) {
 						// System.out.println("SuperBack!");
 						_MouseTimer.setDelay(ZERO_MOUSE_PAUSE);
@@ -829,12 +777,10 @@
 			});
 
-	private static void setPulse(boolean pulseOn) {
-		if (_pulseOn == pulseOn) {
-			return;
-		}
+	private static void setPulse(boolean pulseOn)
+	{
+		if (_pulseOn == pulseOn) return;
+
 		int amount = PULSE_AMOUNT;
-		if (!pulseOn) {
-			amount *= -1;
-			}
+		if (!pulseOn) amount *= -1;
 		_pulseOn = pulseOn;
 
@@ -859,7 +805,4 @@
 				}
 			});
-
-	public void mouseClicked(MouseEvent e) {
-	}
 
 	/**
@@ -874,9 +817,8 @@
 
 	private void ProccessMousePressedEvent(MouseEvent e, int modifiersEx) {
-		// System.out.println("MousePressed " + e.getX() + "," + e.getY() + " "
-		// + e.getWhen());
+		// System.out.println("MousePressed " + e.getX() + "," + e.getY() + " " + e.getWhen());
 
 		// TODO WHY DID I NOT COMMENT THIS LINE!! MIKE SAYS
-		if (LastRobotX != null) {
+/*		if (LastRobotX != null) {
 			_RobotTimer.stop();
 			LastRobotX = null;
@@ -894,9 +836,8 @@
     		MouseX = panStartX;
     		MouseY = panStartY;
-		}
+		}*/
 
 		// System.out.println(modifiersEx);
-		if (_mouseDown == 0)
-			_lastMouseClickDate = new Date();
+		if (_mouseDown == 0) _lastMouseClickDate = new Date();
 
 		int buttonPressed = e.getButton();
@@ -916,24 +857,21 @@
 		 * backup stack.
 		 */
-		if (on == null || buttonPressed != MouseEvent.BUTTON1
-				|| !on.isFrameName()) {
+		if (on == null || buttonPressed != MouseEvent.BUTTON1 || !on.isFrameName()) {
 			Navigation.ResetLastAddToBack();
 		}
 
-		SessionStats.MouseClicked(e.getButton());
+		//SessionStats.MouseClicked(e.getButton());
 		if (buttonPressed == MouseEvent.BUTTON1) {
-			SessionStats.AddFrameEvent("Ld");
+			//SessionStats.AddFrameEvent("Ld");
 			_extrude = false;
 		} else if (buttonPressed == MouseEvent.BUTTON2) {
-			SessionStats.AddFrameEvent("Md");
+			//SessionStats.AddFrameEvent("Md");
 			_extrude = false;
 		} else if (buttonPressed == MouseEvent.BUTTON3) {
-			SessionStats.AddFrameEvent("Rd");
+			//SessionStats.AddFrameEvent("Rd");
 
 			// Check if the user picked up a paint brush
-			if (FreeItems.getInstance().size() == 1
-					&& FreeItems.getItemAttachedToCursor().isAutoStamp()) {
-				int delay = (int) (FreeItems.getItemAttachedToCursor()
-						.getAutoStamp() * 1000);
+			if (FreeItems.getInstance().size() == 1 && FreeItems.getItemAttachedToCursor().isAutoStamp()) {
+				int delay = (int) (FreeItems.getItemAttachedToCursor().getAutoStamp() * 1000);
 				if (delay < 10) {
 					_autoStamp = true;
@@ -958,13 +896,12 @@
 		 */
 		if (_lastClickedOn == null && FreeItems.getInstance().size() == 0) {
-			// System.out.println(e.getClickCount());
 			if (e.getClickCount() >= 2) {
 				_MouseTimer.start();
 			}
-		} else if (_lastClickedOn != null
-				&& FreeItems.getInstance().size() == 0
-				&& e.getButton() == MouseEvent.BUTTON3) {
+		} else if (	_lastClickedOn != null &&
+					FreeItems.getInstance().size() == 0 &&
+					e.getButton() == MouseEvent.BUTTON3)
+		{
 			_ExtrudeMouseTimer.start();
-
 		} else {
 			_MouseTimer.start();
@@ -994,14 +931,15 @@
 			_isDelete = false;
 			_isNoOp = true;
-		} else
+		} else {
 			_isDelete = false;
+		}
 
 		// This must happen before the previous code
 		// This is when the user is anchoring something
-		if (buttonPressed != MouseEvent.BUTTON1
-				&& (_context == CONTEXT_FREESPACE || _context == CONTEXT_AT_ENCLOSURE)
-				&& FreeItems.itemsAttachedToCursor()) {
-			FrameGraphics.changeHighlightMode(_lastHighlightedItem,
-					Item.HighlightMode.None);
+		if (	buttonPressed != MouseEvent.BUTTON1 &&
+				(_context == CONTEXT_FREESPACE || _context == CONTEXT_AT_ENCLOSURE) &&
+				FreeItems.hasItemsAttachedToCursor())
+		{
+			FrameGraphics.changeHighlightMode(_lastHighlightedItem, Item.HighlightMode.None);
 
 			_lastHighlightedItem = FreeItems.getItemAttachedToCursor();
@@ -1010,9 +948,8 @@
 			}
 			FrameGraphics.Repaint();
-			// this is when the user is picking something up
+		// this is when the user is picking something up
 		} else if (_lastHighlightedItem != null) {
 			if (!(_lastHighlightedItem instanceof Line)) {
-				_lastHighlightedItem
-						.setHighlightColor(Item.DEPRESSED_HIGHLIGHT);
+				_lastHighlightedItem.setHighlightColor(Item.DEPRESSED_HIGHLIGHT);
 			} else {
 				for (Item i : _lastHighlightedItem.getAllConnected()) {
@@ -1027,6 +964,5 @@
 			_lastRanged = (Text) on;
 			// set start-drag point
-			_lastRanged.setSelectionStart(DisplayIO.getMouseX(),
-					FrameMouseActions.getY());
+			_lastRanged.setSelectionStart(DisplayIO.getMouseX(), DisplayIO.getMouseY());
 		}
 
@@ -1040,10 +976,8 @@
 		}
 
-		if (on != null && on instanceof Picture
-				&& e.getButton() == MouseEvent.BUTTON3 && !_isDelete) {
+		if (on != null && on instanceof Picture && e.getButton() == MouseEvent.BUTTON3 && !_isDelete) {
 			_lastCropped = (Picture) on;
 			// set start crop point
-			_lastCropped.setStartCrop(DisplayIO.getMouseX(), FrameMouseActions
-					.getY());
+			_lastCropped.setStartCrop(DisplayIO.getMouseX(), DisplayIO.getMouseY());
 			_lastCropped.setShowCrop(true);
 		}
@@ -1055,5 +989,5 @@
 		// System.out.println("Released " + e.getX() + "," + e.getY() + " " +
 		// e.getWhen());
-		FrameUtils.ResponseTimer.restart();
+//		FrameUtils.ResponseTimer.restart();
 		_autoStampTimer.stop();
 		_autoStamp = false;
@@ -1063,10 +997,9 @@
 		// the user probably wants to click away the popup - therefore ignore
 		// the event
-		boolean shouldConsume = PopupManager.getInstance()
-				.shouldConsumeBackClick();
+/*		boolean shouldConsume = PopupManager.getInstance().shouldConsumeBackClick(); TODO: Reinstate. cts16
 		PopupManager.getInstance().hideAutohidePopups();
 		if (shouldConsume && e.getButton() == MouseEvent.BUTTON1) {
 			return; // consume back click event
-		}
+		}*/
 
 		// _lastMovedDistance = new Point(e.getX() - _lastMouseClick.getX(), e
@@ -1084,6 +1017,5 @@
 		// They are probably trying to pick something up in this case
 		if (lastRanged != null) {
-			long depressTime = (new Date()).getTime()
-					- _lastMouseClickDate.getTime();
+			long depressTime = (new Date()).getTime() - _lastMouseClickDate.getTime();
 			// double changeInDistance =
 			// e.getPoint().distance(_currentMouseClick.getPoint());
@@ -1092,6 +1024,5 @@
 			// System.out.println(depressTime);
 
-			if (depressTime < MINIMUM_RANGE_DEPRESS_TIME
-					|| lastRanged.getSelectionSize() <= 0) {// Text.MINIMUM_RANGED_CHARS)
+			if (depressTime < MINIMUM_RANGE_DEPRESS_TIME || lastRanged.getSelectionSize() <= 0) {// Text.MINIMUM_RANGED_CHARS)
 				// {
 				lastRanged.clearSelection();
@@ -1145,8 +1076,7 @@
 
 			if (_lastHighlightedItem != null)
-				FrameGraphics.changeHighlightMode(_lastHighlightedItem,
-						Item.HighlightMode.None);
-
-			if (FreeItems.itemsAttachedToCursor()) {
+				FrameGraphics.changeHighlightMode(_lastHighlightedItem, Item.HighlightMode.None);
+
+			if (FreeItems.hasItemsAttachedToCursor()) {
 				move(FreeItems.getInstance());
 			}
@@ -1174,6 +1104,7 @@
 					lastRanged.replaceSelectedText(((Text) i).getText());
 					FreeItems.getInstance().clear();
-				} else
+				} else {
 					lastRanged.cutSelectedText();
+				}
 				lastRanged.clearSelection();
 				FrameGraphics.Repaint();
@@ -1231,8 +1162,6 @@
 				// Check if the user is trying to range an item for which they
 				// do not have permission to do so... or it is the frame name
-				if (!lastRanged.hasPermission(UserAppliedPermission.full)
-						|| lastRanged.isFrameName()) {
-					MessageBay
-							.displayMessage("Insufficient permission to cut text");
+				if (!lastRanged.hasPermission(UserAppliedPermission.full) || lastRanged.isFrameName()) {
+					MessageBay.displayMessage("Insufficient permission to cut text");
 					lastRanged.clearSelection();
 					FrameGraphics.Repaint();
@@ -1241,6 +1170,5 @@
 				// if the entire text is selected and its not a line end then
 				// pickup the item
-				boolean entireText = lastRanged.getSelectionSize() == lastRanged
-						.getLength();
+				boolean entireText = lastRanged.getSelectionSize() == lastRanged.getLength();
 				if (entireText && !lastRanged.isLineEnd()) {
 					lastRanged.clearSelection();
@@ -1262,6 +1190,5 @@
 				// do not have permission to do so... or it is the frame name
 				if (!lastRanged.hasPermission(UserAppliedPermission.copy)) {
-					MessageBay
-							.displayMessage("Insufficient permission to copy text");
+					MessageBay.displayMessage("Insufficient permission to copy text");
 					lastRanged.clearSelection();
 					FrameGraphics.Repaint();
@@ -1272,5 +1199,5 @@
 
 			ranged.setParent(null);
-			ranged.setPosition(DisplayIO.getMouseX(), FrameMouseActions.getY());
+			ranged.setPosition(DisplayIO.getMouseX(), DisplayIO.getMouseY());
 			pickup(ranged);
 			lastRanged.clearSelection();
@@ -1303,6 +1230,5 @@
 				// MIKE put the code below up here
 				_lastCropped.clearCropping();
-				FrameGraphics.changeHighlightMode(_lastCropped,
-						HighlightMode.None);
+				FrameGraphics.changeHighlightMode(_lastCropped, HighlightMode.None);
 				_lastCropped = null;
 				FrameGraphics.Repaint();
@@ -1341,6 +1267,5 @@
 
 		// error, we should have returned by now
-		System.out.println("Error: mouseReleased should have returned by now. "
-				+ e);
+		System.out.println("Error: mouseReleased should have returned by now. " + e);
 	}
 
@@ -1348,6 +1273,6 @@
 	 * This method handles all left-click actions
 	 */
-	private void leftButton(Item clicked, Collection<Item> clickedIn,
-			boolean isShiftDown, boolean isControlDown) {
+	private void leftButton(Item clicked, Collection<Item> clickedIn, boolean isShiftDown, boolean isControlDown)
+	{
 		
 		//Gets the current frame
@@ -1355,9 +1280,9 @@
 		
 		//Checks if the current frame is an overlay
-		if(f.getOverlays() != null && FrameUtils.getCurrentItem() != null){
+		if (f.getOverlays() != null && FrameUtils.getCurrentItem() != null) {
 			Item i = FrameUtils.getCurrentItem();
 			
 			//Checks if the item clicked in the overlay is a Rubbish Bin. If it is, delete the item attached to the cursor and return.
-			if(i instanceof WidgetCorner){
+/*			if(i instanceof WidgetCorner){ TODO: Reinstate. cts16
 				
 				try{
@@ -1375,5 +1300,5 @@
 					e.printStackTrace();
 				}
-			}
+			}*/
 			
 			Item on = _lastClickedOn;
@@ -1387,5 +1312,5 @@
 			// Check if the user is nearby another item...
 			int mouseX = DisplayIO.getMouseX();
-			int mouseY = FrameMouseActions.getY();
+			int mouseY = DisplayIO.getMouseY();
 			// System.out.println(mouseX + "," + mouseY);
 			for (Item i : DisplayIO.getCurrentFrame().getItems()) {
@@ -1411,9 +1336,8 @@
 		
 		// If the user clicked into a widgets free space...
-		if (clicked == null && _lastClickedIn != null
-				&& _lastClickedIn.size() >= 4) {
+		if (clicked == null && _lastClickedIn != null && _lastClickedIn.size() >= 4) {
 
 			// Check to see if the user clicked into a widgets empty space
-			InteractiveWidget iw = null;
+/*			InteractiveWidget iw = null; TODO: Reinstate. cts16
 
 			for (Item i : _lastClickedIn) {
@@ -1441,5 +1365,5 @@
 				assert (widgetLink != null);
 				clicked = widgetLink;
-			} else {
+			} else*/ {
 				for (Item i : _lastClickedIn) {
 					/*
@@ -1464,5 +1388,5 @@
 			Picture clickedOnPicture = (Picture)clicked;
 			Frame current_frame = DisplayIO.getCurrentFrame();
-			Color bg_col = current_frame.getBackgroundColor();
+			Colour bg_col = current_frame.getBackgroundColor();
 			if (clickedOnPicture.MouseOverBackgroundPixel(mouseX,mouseY,bg_col)) {
 				// Make 'clicked' null, effectively causing a back() operation
@@ -1475,8 +1399,7 @@
 			boolean hasLinkOrAction = clicked.hasLink() || clicked.hasAction();
 
-			if ((hasLinkOrAction && !clicked
-					.hasPermission(UserAppliedPermission.followLinks))
-					|| (!hasLinkOrAction && !clicked
-							.hasPermission(UserAppliedPermission.createFrames))) {
+			if ((hasLinkOrAction && !clicked.hasPermission(UserAppliedPermission.followLinks))
+					|| (!hasLinkOrAction && !clicked.hasPermission(UserAppliedPermission.createFrames)))
+			{
 				Item editTarget = clicked.getEditTarget();
 				if (editTarget != clicked) {
@@ -1484,6 +1407,5 @@
 						clicked = editTarget;
 					} else {
-						MessageBay
-								.displayMessage("Insufficient permission to perform action on item");
+						MessageBay.displayMessage("Insufficient permission to perform action on item");
 						return;
 					}
@@ -1494,10 +1416,9 @@
 
 			// actions take priority
-			if (_lastMouseClick != null && !_lastMouseClick.isControlDown()
-					&& clickedOn.hasAction()) {
+			if (_lastMouseClick != null && !_lastMouseClick.isControlDown() && clickedOn.hasAction()) {
 				IndirectMouseActions.getInstance().getExecuteActionAction().exec(new MouseInfo(clicked, clickedIn, isShiftDown, isControlDown));
 			} else if (clickedOn.getLink() != null) {
 				IndirectMouseActions.getInstance().getFollowLinkAction().exec(new MouseInfo(clicked, clickedIn, isShiftDown, isControlDown));
-				// no link is found, perform TDFC
+			// no link is found, perform TDFC
 			} else {
 				/*
@@ -1519,51 +1440,4 @@
 	}
 
-	private static boolean doMerging(Item clicked) {
-		if (clicked == null)
-			return false;
-
-		// // Brook: widgets do not merge
-		// if (clicked instanceof WidgetCorner)
-		// return false;
-		//
-		// // Brook: widgets do not merge
-		// if (clicked instanceof WidgetEdge)
-		// return false;
-
-		// System.out.println(FreeItems.getInstance().size());
-		if (isRubberBandingCorner()) {
-			if (clicked.isLineEnd()
-					|| clicked.getAllConnected().contains(
-							FreeItems.getItemAttachedToCursor())) {
-				return true;
-			}
-		}
-
-		if (FreeItems.getInstance().size() > 2)
-			return false;
-
-		Item attachedToCursor = FreeItems.getItemAttachedToCursor();
-
-		if (clicked instanceof Text
-				&& !(attachedToCursor instanceof Text || attachedToCursor
-						.isLineEnd())) {
-			return false;
-		}
-
-		if (clicked instanceof Picture) {
-			int mouseX = DisplayIO.getMouseX();
-			int mouseY = FrameMouseActions.getY();
-			Picture clickedOnPicture = (Picture)clicked;
-			Frame current_frame = DisplayIO.getCurrentFrame();
-			Color bg_col = current_frame.getBackgroundColor();
-			if (clickedOnPicture.MouseOverBackgroundPixel(mouseX,mouseY,bg_col)) {
-				// Make 'clicked' null, effectively causing a back() operation
-				return false;
-			}
-		}
-		
-		return true;
-	}
-
 	public static void middleButton() {
 		Item currentItem = FrameUtils.getCurrentItem();
@@ -1582,6 +1456,5 @@
 	public static void leftButton() {
 		Item currentItem = FrameUtils.getCurrentItem();
-		getInstance().leftButton(currentItem,
-				FrameUtils.getCurrentItems(currentItem), false, false);
+		getInstance().leftButton(currentItem, FrameUtils.getCurrentItems(currentItem), false, false);
 		updateCursor();
 	}
@@ -1590,6 +1463,6 @@
 	 * This method handles all middle-click actions
 	 */
-	private void middleButton(Item clicked, Collection<Item> clickedIn,
-			boolean isShiftDown) {
+	private void middleButton(Item clicked, Collection<Item> clickedIn, boolean isShiftDown)
+	{
 		
 		// If the user clicked into a widgets free space...
@@ -1598,5 +1471,5 @@
 
 			// Check to see if the use clicked into a widgets empty space
-			InteractiveWidget iw = null;
+/*			InteractiveWidget iw = null; TODO: Reinstate. cts16
 
 			for (Item i : _lastClickedIn) {
@@ -1617,10 +1490,9 @@
 					return;
 				}
-			}
+			}*/
 		}
 		// if the cursor has Items attached
-		if (FreeItems.itemsAttachedToCursor()) {
-			// if the user is pointing at something, merge the items (if
-			// possible)
+		if (FreeItems.hasItemsAttachedToCursor()) {
+			// if the user is pointing at something, merge the items (if possible)
 			if (doMerging(clicked)) {
 				IndirectMouseActions.getInstance().getDeleteItemsAction().exec(new MouseInfo(clicked, clickedIn, false, false));
@@ -1635,5 +1507,5 @@
 				Picture clickedOnPicture = (Picture)clicked;
 				Frame current_frame = DisplayIO.getCurrentFrame();
-				Color bg_col = current_frame.getBackgroundColor();
+				Colour bg_col = current_frame.getBackgroundColor();
 				if (clickedOnPicture.MouseOverBackgroundPixel(mouseX,mouseY,bg_col)) {
 					clicked = null; // Effectively make it as if they haven't clicked on anything
@@ -1645,10 +1517,8 @@
 				if (!clicked.hasPermission(UserAppliedPermission.full)) {
 					Item editTarget = clicked.getEditTarget();
-					if (editTarget != clicked
-							&& editTarget.hasPermission(UserAppliedPermission.full)) {
+					if (editTarget != clicked && editTarget.hasPermission(UserAppliedPermission.full)) {
 						clicked = editTarget;
 					} else {
-						MessageBay
-						.displayMessage("Insufficient permission to pick up item");
+						MessageBay.displayMessage("Insufficient permission to pick up item");
 						return;
 					}
@@ -1663,48 +1533,4 @@
 		}
 		SessionStats.MovedItems(FreeItems.getInstance());
-	}
-
-	private static Item getFirstFreeLineEnd() {
-		for (Item i : FreeItems.getInstance())
-			if (i.isLineEnd())
-				return i;
-		return null;
-	}
-
-	private static boolean isRubberBandingCorner() {
-		return getShapeCorner(FreeItems.getInstance()) != null;
-	}
-
-	/**
-	 * Gets the rectangle corner from the list of items that are part of a
-	 * rectangle.
-	 * 
-	 * @param partialRectangle
-	 *            a corner and its two connecting lines.
-	 * @return the rectangle corner or null if the list of items is not part of
-	 *         a rectangle.
-	 */
-	private static Item getShapeCorner(List<Item> partialRectangle) {
-		if (partialRectangle.size() < 3)
-			return null;
-		Item lineEnd = null;
-		// only one lineEnd will be present for rectangles
-		// All other items must be lines
-		for (Item i : partialRectangle) {
-			if (i.isLineEnd()) {
-				if (lineEnd == null) {
-					lineEnd = i;
-				} else {
-					return null;
-				}
-			} else if (!(i instanceof Line)) {
-				return null;
-			}
-		}
-		// if this is at least the corner of two connected lines
-		if (lineEnd != null && lineEnd.getAllConnected().size() >= 5)
-			return lineEnd;
-
-		return null;
 	}
 
@@ -1719,5 +1545,5 @@
 
 			// Check to see if the use clicked into a widgets empty space
-			InteractiveWidget iw = null;
+/*			InteractiveWidget iw = null; TODO: Reinstate. cts16
 
 			for (Item i : _lastClickedIn) {
@@ -1738,5 +1564,5 @@
 					return;
 				}
-			}
+			}*/
 		}
 		
@@ -1744,13 +1570,11 @@
 
 		List<Item> copies = null;
-		if (FreeItems.itemsAttachedToCursor()) {
-			if (FreeItems.getInstance().size() == 1
-					&& FreeItems.getItemAttachedToCursor().isAutoStamp()) {
+		if (FreeItems.hasItemsAttachedToCursor()) {
+			if (FreeItems.getInstance().size() == 1 && FreeItems.getItemAttachedToCursor().isAutoStamp()) {
 				// Dont stamp if the user is painting... because we dont want to
 				// save any of the items created!
 				return;
-				// if the user is clicking on something, merge the items
-				// unless it is a point onto something other than a lineEnd or a
-				// dot
+			// if the user is clicking on something, merge the items unless
+			// it is a point onto something other than a lineEnd or a dot
 			} else if (clicked != null
 			// TODO Change the items merge methods so the logic is simplified
@@ -1758,17 +1582,13 @@
 							|| clicked instanceof Dot || clicked.isLineEnd())) {
 				// check permissions
-				if (!clicked.hasPermission(UserAppliedPermission.full)
-						&& clicked.getParent().getNameItem() != clicked) {
-					MessageBay
-							.displayMessage("Insufficient permission to merge items");
+				if (!clicked.hasPermission(UserAppliedPermission.full) && clicked.getParent().getNameItem() != clicked) {
+					MessageBay.displayMessage("Insufficient permission to merge items");
 					return;
 				}
-				if (clicked instanceof Text || clicked instanceof Dot
-						|| clicked instanceof XRayable) {
+				if (clicked instanceof Text || clicked instanceof Dot || clicked instanceof XRayable) {
 					if (isRubberBandingCorner()) {
 						copies = IndirectMouseActions.getInstance().getMergeGroupAction().exec(new MouseInfo(clicked, clickedIn, false, false));
 						// line onto something
-					} else if (FreeItems.getInstance().size() == 2
-					/* && clicked instanceof XRayable */) {
+					} else if (FreeItems.getInstance().size() == 2 /* && clicked instanceof XRayable */) {
 						copies = IndirectMouseActions.getInstance().getMergeTwoItemsAction().exec(new MouseInfo(clicked, clickedIn, false, false));
 					} else if (FreeItems.getInstance().size() == 1) {
@@ -1778,8 +1598,6 @@
 					}
 				} else {
-					copies = ItemUtils.UnreelLine(FreeItems.getInstance(),
-							_controlDown);
-					if (copies == null)
-						copies = copy(FreeItems.getInstance());
+					copies = ItemUtils.UnreelLine(FreeItems.getInstance(), _controlDown);
+					if (copies == null) copies = copy(FreeItems.getInstance());
 					for (Item i : copies) {
 						i.setOffset(0, 0);
@@ -1789,5 +1607,5 @@
 					pickup(copies);
 				}
-				// otherwise, anchor the items
+			// otherwise, anchor the items
 			} else {
 				// check if this is anchoring a rectangle
@@ -1812,5 +1630,5 @@
 				Picture clickedOnPicture = (Picture)clicked;
 				Frame current_frame = DisplayIO.getCurrentFrame();
-				Color bg_col = current_frame.getBackgroundColor();
+				Colour bg_col = current_frame.getBackgroundColor();
 				if (clickedOnPicture.MouseOverBackgroundPixel(mouseX,mouseY,bg_col)) {
 					clicked = null; // Effectively make it as if they haven't clicked on anything
@@ -1823,6 +1641,5 @@
 				if (clicked.isLineEnd()) {
 					if (!clicked.hasPermission(UserAppliedPermission.full)) {
-						MessageBay
-								.displayMessage("Insufficient permission to unreel");
+						MessageBay.displayMessage("Insufficient permission to unreel");
 						return;
 					}
@@ -1833,6 +1650,5 @@
 						clicked = editTarget;
 					} else {
-						MessageBay
-								.displayMessage("Insufficient permission to copy");
+						MessageBay.displayMessage("Insufficient permission to copy");
 						return;
 					}
@@ -1846,6 +1662,5 @@
 					// otherwise, create a rectangle
 				} else {
-					Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(),
-							MouseX, MouseY, true);
+					Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(), MouseX, MouseY, true);
 					// if its on a line then create a line from that line
 					if (on instanceof Line && on.hasPermission(UserAppliedPermission.full)) {
